# Port Applications
 The port application brings a unique cross-section of data connecting vessels, fixtures, and pricing. Knowing this we designed the port application to easily traverse all of its related data points. Like the other applications, a navigation menu can be reached by clicking on the hamburger button located in the top left-hand corner of the display. The port application is divided into three sections:
 
 * Port Details
 * Documents 
 * Emails

![alt text](./media/PortNavigation.png "Title")  

## Port Details

### Port AIS data
With the use of our vessel AIS data, we can provide insight into vessel availability in a region. A map will be rendered at the top of the page; the map will be centered around the queried port and surrounding that port will be a cluster of red markers. Each one of these markers is a vessel located at or around the current port. These markers contain metadata related to the vessel, and each one of these markers can be clicked to pull accessory data about the chosen vessel. When a vessel is chosen, a red circle will surround the vessel, and a card below the map will render the vessel's information. 

![alt text](./media/PortVesselAIS.png "Title")  

The card will render vessel's name, trading status, category, Imo number, and other specifications will be displayed on the card below. Also, a button labeled "View Vessel" will be at the base of the card, the button will navigate users to the vessel's application page.

### Port Details
Below the map component is a card that contains all of the port's descriptive details:

* Port Name
* Country Code
* UNCTAD Code
* Max Draft
* Water Type
* Location
* List of nearby ports

### Cost

This section displays historical rates for different vessels related to the selected port. Each rate type is separated into its corresponding table and each table is ordered in descending chronological order. 

![alt text](./media/PortCost.png "Title") 

In the upper right-hand corner of the card is a button labeled "Add New Cost", by clicking this button a pop-up will be displayed on the screen. Three fields will be displayed: Vessel Type, a drop-down menu with available vessel types, a Date Picker to choose which date the rate was reported, and an input field for the declared rate value.

![alt text](./media/PortAddCost.png "Title") 

### Fixtures
This module shows all fixtures discharging and loading from the selected port, the data is separated by tabs. Since a port can have many vessel's loading or discharging vessels; the results are split into pages. The buttons located at the bottom of the card can help users navigate to the previous and the next page of data. Additionally, the results can be sorted in three ways to help users navigate through results; users can sort by lay can date, reported date, and vessel name.

![alt text](./media/PortFixtures.png "Title") 

### Description

Port description is a collection of notes generated by McQuilling employees over time. These notes can contain any data that Operation teams find pertinent, such as vessel charges than may ensue, or websites containing port information.

### Terminals
A port may have many terminals related to it, every terminal has different specifications related to that terminal. A list of terminals will be rendered as a column of buttons, when clicked each button will reveal notes related to the terminal associated with the button. This information has been entered by operations employees over the years, if new data about a terminal needs to be submitted; enter it via the MLISA client or submit a help desk ticket with ICT.

![alt text](./media/Terminals.png "Title") 

### Contact Details

Contact details contain the contact information of representatives at each port previously entered by operations employees, if information needs to be added or updated; please submit that information through the MLISA desktop client or submit a help desk ticket to ICT. 

## Documents
Many of McQuillings record types can attach different forms of documents to the record itself, this may be helpful for filing purposes as well as the sharing of documents with other McQuiling employees. Any file type can be stored and attached to a port record, the web application is also helpful for rendering and downloading those documents. 
Once a user has navigated to the Document section of the application, a list of uploaded documents will render in chronological order. From this screen, a user can view any document by simply clicking on it. If the file type is one of Microsoft's proprietary file types a download will occur, because Microsoft products require software to render; otherwise a pop-up box will appear and the document will render in the browser. 

![alt text](./media/PortDocuments.png "Title") 

Additionally, a user can easily add a new document to a port by dragging and dropping the file on top of the render lists of documents, a pop-up will appears asking for the name of the recently dropped document. Once a name is supplied, click ok and the document will be submitted and listed at the top list that is generated. 

## Emails

Like documents, many record types can attach emails; emails filed with the application become tagged in the front email client. This means emails in front can be easily searched for and can also contain a link to the port record. Since emails are used to communicate new information about ports, filed emails usually give the most recent record of events occurring at that port.
 Port emails are separated into multiple folders, each folder would ideally contain a particular type of information. New folders can be easily created by clicking on the New Folder button located in the header of the application. Once created a user can navigate from folder to folder by clicking the name of the current folder, also located in the header of the application; once clicked a list of all attached folders will render. By clicking on the folder the user wants, a list of emails currently in the requested folder will appear. 
Emails will render in rows, each email will list the display company, the description, and the message date; to view additional information, click the email. The email will reveal an additional section with metadata about the email, along with two buttons. From this point, a user can either view that email in its native client or move the email into a different folder attached to the record.

![alt text](./media/PortEmails.png "Title")

To attach a new email to the record, first, navigate to the appropriate folder for the email; this is done by clicking on the current folder's name located in the header. A list of folders associated with the port record will appear, select the appropriate folder. Then open the front email client and find the email, then drag the corresponding email on the interface, the screen will darken, and then drop the email on this darkened screen. A pop-up will appear asking for a description of the email, enter a description and press ok; this will send a background task that will ultimately file the email to the selected folder.